package com.smith9.geiger.client

import com.smith9.geiger.client.beans.Stat
import groovy.xml.MarkupBuilder
import com.smith9.geiger.client.beans.Duration
import org.joda.time.format.ISODateTimeFormat
import simplygroovy.csv.opencsv.OpenCsvWriter
import simplygroovy.csv.CsvWriter

/**
 * Created: 23/05/12
 * @author david
 */
class DurationConverter implements StatConverter {
    void toXml(List<Stat> stats, Writer writer) {
        MarkupBuilder builder = new MarkupBuilder(writer)
        builder.durations() {
            stats.each { durationNode ->
                duration(toMap(durationNode)) {
                    metadata(durationNode.metadata)
                }
            }
        }
    }

    static Map<String, String> toMap(Duration duration) {
        assert duration.startTime, "StartTime is mandatory"
        assert duration.measure, "measure is mandatory"
        Map<String, String> properties = [:]
        properties.put("environment", duration.environment)
        properties.put("productName", duration.product)
        properties.put("subProduct", duration.subProduct)
        properties.put("startTime", duration.startTime.toString(ISODateTimeFormat.dateTime()))
        properties.put("duration", duration.duration)
        properties.put("measure", duration.measure)
        properties.put("grouping", duration.grouping)
        properties.put("reference", duration.reference)
        properties.put("batch", duration.batch)
        properties.put("batchType", duration.batchType)
        properties.put("failure", duration.failure)
        return properties
    }

}
